diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
index 2fa56485e..93c192540 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelMap.java
@@ -26,95 +26,90 @@ import org.lwjgl.opengl.GL12;
 
 public class ItemModelMap extends ItemModelStandard {
     private final Minecraft mc = Minecraft.getMinecraft();
-    private final MapItemRenderer renderMapInstance = new MapItemRenderer(mc.font, mc.gameSettings, mc.textureManager);
+    private final MapItemRenderer renderMapInstance = new MapItemRenderer();
 
     public ItemModelMap(Item item, String namespace) {
         super(item, namespace);
     }
-
     @Override
-    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
-    	int blockX = MathHelper.floor(player.x);
-    	int blockY = MathHelper.floor(player.y);
-    	int blockZ = MathHelper.floor(player.z);
-    	
-        // Apply appropriate brightness
-        float brightness = 1.0f;
-        if(LightmapHelper.isLightmapEnabled()) {
-        	LightmapHelper.setLightmapCoord(mc.currentWorld.getLightmapCoord(blockX, blockY, blockZ, 0));
-        }else if(mc.fullbright) {
-        	
-        }else {
-        	brightness = mc.currentWorld.getLightBrightness(blockX, blockY, blockZ);
-        }
-        GL11.glColor4f(brightness, brightness, brightness, 1.0f);
+    public void renderFirstPerson(@NotNull Tessellator tessellator, @NotNull ItemRenderer itemRenderer, @NotNull Player player, @NotNull ItemStack itemStack, float brightness, float alpha, float partialTick) {
+        // The map renders very differently from any other item, so has its own custom first person render code
+        if (ItemMap.hasInitialized(itemStack)) {
+            GL11.glPushMatrix();
+            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
-        final float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
-        final float swingProgress = player.getSwingProgress(partialTick);
-        final float f_z = MathHelper.sin(swingProgress * MathHelper.PI);
-        final float f_x = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-        GL11.glTranslatef(-f_x * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -f_z * 0.2F);
+            final float rotationPitch = player.xRotO + (player.xRot - player.xRotO) * partialTick;
+            final float swingProgress = player.getSwingProgress(partialTick);
+            final float f_z = MathHelper.sin(swingProgress * MathHelper.PI);
+            final float f_x = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+            GL11.glTranslatef(-f_x * 0.4F, MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI * 2.0F) * 0.2F, -f_z * 0.2F);
 
-        float f_val = MathHelper.clamp((1.0F - rotationPitch / 45F) + 0.1F, 0, 1);
-        f_val = -MathHelper.cos(f_val * MathHelper.PI) * 0.5F + 0.5F;
-        final float zOff = 0.8F * -0.9F;
-        GL11.glTranslatef(0.0F, (-(1.0F - renderer.getEquippedProgress(partialTick)) * 1.2F - f_val * 0.5F) + 0.04F, zOff); // Place map at right distance from camera
-        GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(f_val * -85F, 0.0F, 0.0F, 1.0F);
-        GL11.glEnable(GL12.GL_RESCALE_NORMAL);
+            float f_val = MathHelper.clamp((1.0F - rotationPitch / 45F) + 0.1F, 0, 1);
+            f_val = -MathHelper.cos(f_val * MathHelper.PI) * 0.5F + 0.5F;
+            final float zOff = 0.8F * -0.9F;
+            GL11.glTranslatef(0.0F, (-(1.0F - itemRenderer.getEquippedProgress(partialTick)) * 1.2F - f_val * 0.5F) + 0.04F, zOff); // Place map at right distance from camera
+            GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(f_val * -85F, 0.0F, 0.0F, 1.0F);
+            GL11.glEnable(GL12.GL_RESCALE_NORMAL);
 
-        // Render both player arms
-        mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
-        MobRendererPlayer playerRenderer = (MobRendererPlayer) (EntityRenderer<? extends Entity>) EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
+            // Render both player arms
+            mc.textureManager.bindDownloadableTexture(mc.thePlayer.skinURL, mc.thePlayer.getEntityTexture(), PlayerSkinParser.instance);
+            MobRendererPlayer playerRenderer = (MobRendererPlayer) (EntityRenderer<? extends Entity>) EntityRenderDispatcher.instance.getRenderer(mc.thePlayer);
 
-        GL11.glPushMatrix();
-        GL11.glTranslatef(-0F, -0.6F, -1.1F);
-        GL11.glRotatef(180, 0, 1, 0);
-        GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
-        GL11.glRotatef(90F - 59F, 0.0F, 0.0F, 1.0F);
-        GL11.glRotatef(65, 0.0F, 1.0F, 0.0F);
-        playerRenderer.drawFirstPersonHand(mc.thePlayer, true);
-        GL11.glPopMatrix();
-        GL11.glPushMatrix();
-        GL11.glTranslatef(-0F, -0.6F, 1.1F);
-        GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
-        GL11.glRotatef(-90F + 59F, 0.0F, 0.0F, 1.0F);
-        GL11.glRotatef(-65, 0.0F, 1.0F, 0.0F);
-        playerRenderer.drawFirstPersonHand(mc.thePlayer, false);
-        GL11.glPopMatrix();
+            GL11.glPushMatrix();
+            GL11.glTranslatef(-0F, -0.6F, -1.1F);
+            GL11.glRotatef(180, 0, 1, 0);
+            GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(90F - 59F, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(65, 0.0F, 1.0F, 0.0F);
+            playerRenderer.drawFirstPersonHand(mc.thePlayer, true);
+            GL11.glPopMatrix();
+            GL11.glPushMatrix();
+            GL11.glTranslatef(-0F, -0.6F, 1.1F);
+            GL11.glRotatef(-45, 1.0F, 0.0F, 0.0F);
+            GL11.glRotatef(-90F + 59F, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(-65, 0.0F, 1.0F, 0.0F);
+            playerRenderer.drawFirstPersonHand(mc.thePlayer, false);
+            GL11.glPopMatrix();
 
 
-        final float f_val3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
-        final float f_val4 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
-        GL11.glRotatef(-f_val3 * 20F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(-f_val4 * 20F, 0.0F, 0.0F, 1.0F);
-        GL11.glRotatef(-f_val4 * 80F, 1.0F, 0.0F, 0.0F);
+            final float f_val3 = MathHelper.sin(swingProgress * swingProgress * MathHelper.PI);
+            final float f_val4 = MathHelper.sin(MathHelper.sqrt_float(swingProgress) * MathHelper.PI);
+            GL11.glRotatef(-f_val3 * 20F, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(-f_val4 * 20F, 0.0F, 0.0F, 1.0F);
+            GL11.glRotatef(-f_val4 * 80F, 1.0F, 0.0F, 0.0F);
 
-        final float scale1 = 0.38F;
-        GL11.glScalef(scale1, scale1, scale1);
-        GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
-        GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
-        GL11.glTranslatef(-1F, -1F, 0.0F);
+            final float scale1 = 0.38F;
+            GL11.glScalef(scale1, scale1, scale1);
+            GL11.glRotatef(90F, 0.0F, 1.0F, 0.0F);
+            GL11.glRotatef(180F, 0.0F, 0.0F, 1.0F);
+            GL11.glTranslatef(-1F, -1F, 0.0F);
 
-        final float scale2 = 0.015625F;
-        GL11.glScalef(scale2, scale2, scale2);
+            final float scale2 = 0.015625F;
+            GL11.glScalef(scale2, scale2, scale2);
 
-        GL11.glNormal3f(0.0F, 0.0F, -1F);
+            GL11.glNormal3f(0.0F, 0.0F, -1F);
 
-        // Render paper background of map
-        mc.textureManager.bindTexture(mc.textureManager.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
-        tessellator.startDrawingQuads();
-        final byte expansion = 7; // makes the edges extend around the actual map data by a bit
-        tessellator.addVertexWithUV(-expansion,     128 + expansion, 0.0D, 0.0D, 1.0D);
-        tessellator.addVertexWithUV(128 + expansion,128 + expansion, 0.0D, 1.0D, 1.0D);
-        tessellator.addVertexWithUV(128 + expansion,-expansion,      0.0D, 1.0D, 0.0D);
-        tessellator.addVertexWithUV(-expansion,     -expansion,      0.0D, 0.0D, 0.0D);
-        tessellator.draw();
+            // Render paper background of map
+            mc.textureManager.bindTexture(mc.textureManager.loadTexture("/assets/minecraft/textures/misc/mapbg.png"));
+            tessellator.startDrawingQuads();
+            final byte expansion = 7; // makes the edges extend around the actual map data by a bit
+            tessellator.addVertexWithUV(-expansion,     128 + expansion, 0.0D, 0.0D, 1.0D);
+            tessellator.addVertexWithUV(128 + expansion,128 + expansion, 0.0D, 1.0D, 1.0D);
+            tessellator.addVertexWithUV(128 + expansion,-expansion,      0.0D, 1.0D, 0.0D);
+            tessellator.addVertexWithUV(-expansion,     -expansion,      0.0D, 0.0D, 0.0D);
+            tessellator.draw();
 
-        ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(stack, mc.currentWorld);
-        if (mapData == null) return;
-        renderMapInstance.renderMap(mc.textureManager, mapData, brightness);
+            ItemMapSavedData mapData = Items.MAP.getOrCreateSavedData(itemStack, mc.currentWorld);
+            if (mapData != null) {
+                renderMapInstance.renderMap(tessellator, mapData, brightness);
+            }
+            GL11.glPopMatrix();
+        } else {
+            super.renderFirstPerson(tessellator, itemRenderer, player, itemStack, brightness, alpha, partialTick);
+        }
     }
+
     @Override
     public @NotNull IconCoordinate getIcon(@Nullable Entity entity, ItemStack itemStack){
         if (!ItemMap.hasInitialized(itemStack)){
diff --git a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
index 655d998ca..156213958 100644
--- a/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
+++ b/game/client/src/main/java/net/minecraft/client/render/item/model/ItemModelNone.java
@@ -1,54 +1,27 @@
 package net.minecraft.client.render.item.model;
 
 import net.minecraft.client.render.Font;
-import net.minecraft.client.render.ItemRenderer;
 import net.minecraft.client.render.TextureManager;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.tessellator.Tessellator;
 import net.minecraft.core.entity.Entity;
-import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
+import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
-import java.util.Random;
-
 public class ItemModelNone extends ItemModel{
     public ItemModelNone() {
         super(null);
     }
 
-    @Override
-    public void renderItemFirstPerson(Tessellator tessellator, ItemRenderer renderer, Player player, ItemStack stack, float partialTick) {
-
-    }
-
-    @Override
-    public void renderItem(Tessellator tessellator, ItemRenderer renderer, ItemStack itemstack, @Nullable Entity entity, float brightness, boolean handheldTransform) {
-
-    }
-
-    @Override
-    public void renderItemThirdPerson(Tessellator tessellator, ItemRenderer renderer, Entity entity, ItemStack itemstack, boolean handheldTransform) {
-
-    }
-
-    @Override
-    public void renderItemIntoGui(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemStack, int x, int y, float brightness, float alpha) {
-
-    }
-
-    @Override
-    public void renderItemOverlayIntoGUI(Tessellator tessellator, Font font, TextureManager textureManager, ItemStack itemstack, int x, int y, String override, float alpha) {
-
-    }
 
     @Override
-    public void renderAsItemEntity(Tessellator tessellator, @Nullable Entity entity, Random random, ItemStack itemstack, int renderCount, float yaw, float brightness, float partialTick) {
+    public void render(@NotNull Tessellator tessellator, @Nullable Entity holder, @NotNull ItemStack itemStack, @NotNull String displayPosId, boolean items3d, int clusterSize, float brightness, float alpha, float partialTick, boolean mirrorX) {
 
     }
 
     @Override
-    public void renderItemInWorld(Tessellator tessellator, Entity entity, ItemStack itemStack, float brightness, float alpha, boolean worldTransform) {
+    public void renderItemOverlayIntoGUI(@NotNull Tessellator tessellator, @NotNull Font font, @NotNull TextureManager textureManager, @NotNull ItemStack itemstack, int x, int y, @Nullable String override, float alpha) {
 
     }
 
